#!/usr/bin/env python
# vim: set fileencoding=utf-8 expandtab shiftwidth=4 tabstop=4 softtabstop=4:

import socket
import struct
import math
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
import pygame

width = 1920
height = 1080
fullscreen = 1

s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.bind(('', 20123))
s.setblocking(0)

pygame.init()
glutInit([])
screen = pygame.display.set_mode((width, height), pygame.OPENGL | pygame.DOUBLEBUF | (fullscreen * pygame.FULLSCREEN))
pygame.display.set_caption('Teapot')

clock = pygame.time.Clock()

glEnable(GL_LIGHTING)
glEnable(GL_COLOR_MATERIAL)
glEnable(GL_NORMALIZE)
glShadeModel(GL_SMOOTH)
glEnable(GL_DEPTH_TEST)
glClearColor(0.7, 0.7, 0.7, 0.0)
glColor3d(1.0, 0.0, 0.0)
glViewport(0, 0, width, height)
glMatrixMode(GL_PROJECTION)
glLoadIdentity()
gluPerspective(45, 1.0*width/height, 0.01, 200.0)
glMatrixMode(GL_MODELVIEW)
glLoadIdentity()

glLightfv(GL_LIGHT0,GL_POSITION,[30,30,30,0])
glLightfv(GL_LIGHT0,GL_DIFFUSE,[1,1,1,1])
glLightfv(GL_LIGHT0,GL_SPECULAR,[1,1,1,1])
glEnable(GL_LIGHT0)

data = []
setpoint = 0
angle = 0
last_counter = -1
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            sys.exit()
        elif event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_ESCAPE, pygame.K_q):
                sys.exit()
            elif event.key == pygame.K_SPACE:
                setpoint = angle

    try:
        while True:
            data = s.recv(1024)
    except:
        pass

    glLoadIdentity()
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glTranslate(0.0, 0.0, -4.0)
    #gluLookAt(0.0, 0.0, 6.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)
    if data:
        unpacked = struct.unpack('!q24f', data)
        if unpacked[0] > last_counter:
            last_counter = unpacked[0]
            floats = unpacked[1:]
            #m = floats[6:15]
            #glMultMatrixf([m[0], m[1], m[2], 0,
            #               m[3], m[4], m[5], 0,
            #               m[6], m[7], m[8], 0,
            #                  0,    0,    0, 1])
            m = floats[0:3]
            angle = -math.atan2(m[0], m[1])*180.0/math.pi
        glRotatef(angle-setpoint, 0, 0, 1)
                       

    glutSolidTeapot(1.0)

    pygame.display.flip()
    clock.tick(100)
